from zope.i18nmessageid import MessageFactory
from Products.MegamanicEditContentTypes import config

from Products.Archetypes import atapi
from Products.CMFCore import utils

MailerMessageFactory = MessageFactory('Products.MegamanicEditContentTypes')

from Products.ATContentTypes.config import HAS_LINGUA_PLONE

if not HAS_LINGUA_PLONE:
    from Products.Archetypes.atapi import process_types, listTypes
else:
    from Products.LinguaPlone.public import process_types, listTypes

def initialize(context):
    """Initializer called when used as a Zope 2 product.

    This is referenced from configure.zcml. Regstrations as a "Zope 2 product"
    is necessary for GenericSetup profiles to work, for example.

    Here, we call the Archetypes machinery to register our content types
    with Zope and the CMF.
    """

    # Retrieve the content types that have been registered with Archetypes
    # This happens when the content type is imported and the registerType()
    # call in the content type's module is invoked. Actually, this happens
    # during ZCML processing, but we do it here again to be explicit. Of
    # course, even if we import the module several times, it is only run
    # once.

    content_types, constructors, ftis = atapi.process_types(
        atapi.listTypes(config.PROJECTNAME),
        config.PROJECTNAME)

    # Now initialize all these content types. The initialization process takes
    # care of registering low-level Zope 2 factories, including the relevant
    # add-permission. These are listed in config.py. We use different
    # permissions for each content type to allow maximum flexibility of who
    # can add which content types, where. The roles are set up in rolemap.xml
    # in the GenericSetup profile.
